/** Rill v0.0.4111 https://www.npmjs.com/package/rill License: MIT*/
var byteLength, empty, isType;

isType = require("./isType");

byteLength = require("./byteLength");

empty = {
  204: true,
  205: true,
  304: true
};

module.exports = function*(req, res, next) {
  var body, headers, method, originalRes, status;
  (yield next);
  originalRes = res.originalRes, headers = res.headers, status = res.status, method = res.method, body = res.body;
  if (originalRes.headersSent) {
    return;
  }
  if (empty[status] || (body == null)) {
    headers["Content-Type"] = void 0;
    body = null;
  } else if (isType.String(body)) {
    if (headers["Content-Type"] == null) {
      headers["Content-Type"] = "text/" + (/^\s*</.test(body) ? "html" : "plain");
    }
  } else if (isType.Object(body)) {
    if (headers["Content-Type"] == null) {
      headers["Content-Type"] = "application/json";
    }
    body = JSON.stringify(body);
  } else {
    if (headers["Content-Type"] == null) {
      headers["Content-Type"] = "application/octet-stream";
    }
    if (body.length) {
      if (headers["Content-Length"] == null) {
        headers["Content-Length"] = body.length;
      }
    }
    if (isType.Stream(body)) {
      return body.pipe(originalRes);
    }
  }
  if (headers["Content-Length"] == null) {
    headers["Content-Length"] = byteLength(body);
  }
  if (Number(status) === 404 && isType.Empty(body)) {
    status = 200;
  }
  originalRes.writeHead(status, headers);
  return originalRes.end("HEAD" !== method ? body : void 0);
};
